<?php
/*
Plugin Name: wp-hatena 拡張版
Plugin URI: http://wppluginsj.sourceforge.jp/wp-hatena/
Description: エントリにはてなブックマーク等に追加するリンクタグとはてなブックマーク被リンク数表示を挿入します。
Author: hiromasa / Extended version Author: inocco (hibiki)
Version: 0.93j ( Extended versionin: 0.4 )
Author URI: http://hiromasa.zone.ne.jp/blog/ / Extended version Author URI: http://wp.graphact.com/
Special Thanks: Castaway. (http://bless.babyblue.jp/wp/)
Bug Report: Masayan (http://wp.mmrt-jp.net/)
Bug Report: kohaku (http://aoiro-blog.com/)
*/

/*  Copyright 2006 hiromasa  (email : webmaster@hiromasa.zone.ne.jp)

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

/******************************************************************************
 * 使い方 :
 *  プラグインを有効にした後 WP テーマ内の **エントリ表示位置** に、
 *   はてなの場合      : <?php if(isset($wph)) $wph->addHatena(); ?>
 *   del.icio.usの場合 : <?php if(isset($wph)) $wph->adddelicious(); ?>
 *  を挿入してください。
 *****************************************************************************/

/******************************************************************************
 * WpHatena function define.
 *****************************************************************************/
if(class_exists('WpHatena')) {
	
	$wph = & new WpHatena();
	
	// JavaScript 画像説明ポップアップ用
	// add_action('wp_head', array(&$wph, 'addScript'));
	
}

/******************************************************************************
 * WpHatena
 * 
 * @author		hiromasa
 * @version	0.93j
 * 
 *****************************************************************************/
class WpHatena {
	
	var $plugin_path;
	var $popup_jsname;
	var $blog_charset;
	
	/**
	 * The Constructor
	 * 
	 * @param none
	 * @return Object reference
	 */
	function WpHatena() {
		
		$this->plugin_path  = get_settings('siteurl');
		$this->plugin_path .= '/wp-content/plugins/wp-hatena/';
		$this->popup_jsname = 'popup.js';
		$this->blog_charset = get_settings('blog_charset');
		
	}
	
	/**
	 * WP interface.
	 * 
	 * @param none
	 * @return none (はてなブックマーク用のタグを echo)
	 */
	function addHatena() {
		
		echo
			$this->makeBookmarkURL(
				'はてなブックマーク',
				'http://b.hatena.ne.jp/append?' . get_permalink(),
				'hatena.gif',
				16, 12,
				''
			);
		
	}
	
	/**
	 * WP interface.
	 * 
	 * @param none
	 * @return none (del.icio.us 用のタグを echo)
	 */
	function adddelicious() {
		
		$title = $this->utf8_encode(get_the_title());
		
		echo
			$this->makeBookmarkURL(
				'del.icio.us',
				'http://del.icio.us/post?url=' . get_permalink(),
				'delicious.12px.gif',
				12, 12,
				'&amp;title=' . urlencode($title)
			);
		
	}
	
	/**
	 * WP interface.
	 * 
	 * @param none
	 * @return none (Livedoor Clip用のタグを echo)
	 */
	function addLivedoor() {
		
		$title = $this->utf8_encode(get_the_title());
		
		echo
			$this->makeBookmarkURL(
				'Livedoor Clip',
				'http://clip.livedoor.com/clip/add?link=' . get_permalink(),
				'livedoor.gif',
				16, 16,
				'&amp;title=' . urlencode($title) . '&amp;jump=ref'
			);
		
	}
	
	/**
	 * WP interface.
	 * 
	 * @param none
	 * @return none (Yahoo! ブックマーク用のタグを echo)
	 */
	function addYahoo() {
		
		$title = $this->utf8_encode(get_the_title());
		
		echo
			$this->makeBookmarkURL(
				'Yahoo!ブックマーク',
				'http://bookmarks.yahoo.co.jp/bookmarklet/showpopup?t=' . urlencode($title),
				'yahoo.gif',
				16, 16,
				'&amp;u=' . get_permalink() . '&amp;opener=bm&amp;ei=UTF-8'
			);
		
	}

	/**
	 * WP interface.
	 * 
	 * @param none
	 * @return none (FC2ブックマーク用のタグを echo)
	 */
	function addFC2() {
		
		$title = $this->utf8_encode(get_the_title());
		
		echo
			$this->makeBookmarkURL(
				'FC2ブックマーク',
				'http://bookmark.fc2.com/user/post?url=' . get_permalink(),
				'fc2.gif',
				16, 16,
				'&amp;title=' . urlencode($title)
			);
		
	}
	
	/**
	 * WP interface.
	 * 
	 * @param none
	 * @return none (Nifty用のタグを echo)
	 */
	function addNifty() {
		
		$title = $this->utf8_encode(get_the_title());
		
		echo
			$this->makeBookmarkURL(
				'Nifty Clip',
				'http://clip.nifty.com/create?url=' . get_permalink(),
				'nifty.gif',
				14, 14,
				'&amp;title=' . urlencode($title)
			);
		
	}
	
	/**
	 * WP interface.
	 * 
	 * @param none
	 * @return none (POOKMARK用のタグを echo)
	 */
	function addPOOKMARK() {
		
		$title = $this->utf8_encode(get_the_title());
		
		echo
			$this->makeBookmarkURL(
				'POOKMARK. Airlines',
				'http://pookmark.jp/post?url=' . get_permalink(),
				'pookmark.gif',
				18, 12,
				'&amp;title=' . urlencode($title)
			);
		
	}
	
	/**
	 * WP interface.
	 * 
	 * @param none
	 * @return none (buzzurl用のタグを echo)
	 */
	function addBuzzurl() {
		
		$title = $this->utf8_encode(get_the_title());
		
		echo
			$this->makeBookmarkURL(
				'Buzzurl（バザール）',
				'http://news.ecnavi.jp/config/add/confirm?url=' . get_permalink(),
				'buzzurl.gif',
				21, 15,
				'&amp;title=' . urlencode($title)
			);
		
	}
	
	/**
	 * WP interface.
	 * 
	 * @param none
	 * @return none (Choix用のタグを echo)
	 */
	function addChoix() {
		
		$title = $this->utf8_encode(get_the_title());
		
		echo
			$this->makeBookmarkURL(
				'Choix',
				'http://www.choix.jp/bloglink/' . get_permalink(),
				'choix.gif',
				16, 16,
				''
			);
		
	}
	
	/**
	 * WP interface.
	 * 
	 * @param none
	 * @return none (newsing用のタグを echo)
	 */
	function addnewsing() {
		
		$title = $this->utf8_encode(get_the_title());
		
		echo
			$this->makeBookmarkURL(
				'newsing',
				'http://newsing.jp/nbutton?title=' . urlencode($title),
				'newsing.gif',
				16, 16,
				'&amp;url=' . get_permalink()
			);
		
	}
		
	/**
	 * WP interface.
	 * 
	 * @param none
	 * @return none (はてなブックマーク被ブックマーク用のタグを echo)
	 */
	function addHatenaCount() {
		
		echo
			$this->makeBookmarkCountURL(
				'はてなブックマーク',
				'http://b.hatena.ne.jp/entry/image/' . get_permalink(),
				'http://b.hatena.ne.jp/entry/' . get_permalink()
			);
		
	}
		
	
	/**
	 * Bookmark URL maker.
	 * 
	 * @param $sitename (サイト名称文字列)
	 * @param $url (URL)
	 * @param $iconfile (画像ファイル URL)
	 * @param $width (画像 width)
	 * @param $height (画像 height)
	 * @param $ext_url (その他の追加 URL)
	 * @return $tag (画像リンクタグ)
	 */
	function makeBookmarkURL($sitename, $url, $iconfile, $width, $height, $ext_url) {
		
		$tag  = '<a';
		$tag .= ' href="' . $url . $ext_url . '"';
		$tag .= ' target="_blank"';
		$tag .= ' style="margin-right: 8px;" ';
		$tag .= '>';
		$tag .= '<img';
		$tag .= ' src="' . $this->plugin_path . $iconfile . '"';
		$tag .= ' alt="このエントリを' . $sitename . 'に追加"';
		$tag .= ' title="このエントリを' . $sitename . 'に追加"';
		$tag .= ' width="' . $width . '" height="' . $height . '"';
		$tag .= ' style="border: 0; margin: 0; padding: 0; vertical-align: middle;" ';
		//$tag .= ' onmouseover="wpHatenaPopup()"';
		$tag .= '/>';
		$tag .= '</a>';
		
		return $tag;
		
	}
	
	/**
	 * Bookmark URL maker.
	 * 
	 * @param $sitename (サイト名称文字列)
	 * @param $imgurl (imgURL)
	 * @param $url (URL)
	 * @return $tag (画像リンクタグ)
	 */
	function makeBookmarkCountURL($sitename, $imgurl, $url) {
		
		$tag  = '<a';
		$tag .= ' href="' . $url . '"';
		$tag .= ' target="_blank"';
		$tag .= '>';
		$tag .= '<img';
		$tag .= ' src="' . $imgurl . '"';
		$tag .= ' alt=""';
		$tag .= ' title="このエントリの' . $sitename . '被ブックマーク数"';
		$tag .= ' style="border: 0; margin: 0 8px 0 0; padding: 0; vertical-align: middle;" ';
		//$tag .= ' onmouseover="wpHatenaPopup()"';
		$tag .= '/>';
		$tag .= '</a>';
		
		return $tag;
		
	}
	
	/**
	 * UTF-8 encoder.
	 * 
	 * @param $text
	 * @return $text (UTF-8 に変換した文字列)
	 */
	function utf8_encode($text) {
		
		if(!preg_match ("/UTF-8/i", $this->blog_charset)) {
			if(function_exists('mb_convert_encoding')) {
				$text = 
					mb_convert_encoding(
						$text,
						'UTF-8',
						$this->blog_charset
					);
			}
		}
		
		return $text;
		
	}
	
	/**
	 * WP filter interface.(wp_head)
	 *  - 未使用 (popup.js 未実装のため)
	 * 
	 * @param none
	 * @return none (画像説明ポップアップ JavaScript を echo)
	 */
	function addScript() {
		
		echo '<script type="text/javascript"';
		echo ' src="'. $this->plugin_path . $this->popup_jsname . '"';
		echo '>';
		echo '</script>' . "\n";
		
	}
	
}
?>
